/* CMVC: @(#)38 1.9.17.7 src/export/include/ldap.h.in, ldap.include, aus60ldap, 080702a 6/30/08 06:34:22 */
/*
* COMPONENT_NAME: ldap.include
*
* ABSTRACT: ldap header file
*
* ORIGINS: 202,27
*
* (C) COPYRIGHT International Business Machines Corp. 1997, 2004
* All Rights Reserved
* Licensed Materials - Property of IBM
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/*
 *
 * Licensed Materials - Property of IBM
 * 5647-A01,5722-SS1
 * (C) Copyright IBM Corp. 1997, 2004
 *
 */
/*
 * Copyright (c) 1990 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the
 * University may not be used to endorse or promote products
 * derived from this software without specific prior written
 * permission. This software is provided ``as is'' without express
 * or implied warranty.
 *
 */

#ifndef _LDAP_H
#define _LDAP_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _WIN32
#define SLASH_CHAR              '\\'
#include <winsock.h>
#else
#define SLASH_CHAR  '/'
#if defined ( HPUX )
#include <sys/signal.h>
#endif
#include <sys/time.h>
#endif

#define LDAP_FALSE   0
#define LDAP_TRUE   1

#if defined ( _WIN32 )
#define  LDAP_CODESET_UTF8 "UTF-8"
#define  LDAP_CODESET_UNICODE "UCS-2"
#define  LDAPHOME  "undefined"
#define  LDAPHOMEDEFAULT "C:\\Progra~1\\ibm\\ldap\\V6.0"
#define  LDAP_LIBEXT  "dll"
#define  LDAP_DEFAULT_LOCPATH "undefined"
#define  LDAP_CONFIG_DIR  "undefined"

#elif  defined ( _SOLARIS )
#define  LDAP_CODESET_UTF8 "UTF-8"
#define  LDAP_CODESET_UNICODE "UCS-2"
#define  LDAPHOMEBASE  "/opt/IBM/ldap"
#define  LDAPHOME  "/opt/IBM/ldap/V6.0"
#define  LDAP_LIBEXT  "so"
#define  LDAP_DEFAULT_LOCPATH "/usr/lib/locale"
#define  LDAP_CONFIG_DIR  "/opt/IBM/ldap/V6.0/etc"

#elif defined ( _AIX )
#define  LDAP_CODESET_UTF8 "UTF-8"
#define  LDAP_CODESET_UNICODE "UCS-2"
#define  LDAPHOMEBASE  "/opt/IBM/ldap"
#define  LDAPHOME  "/opt/IBM/ldap/V6.0"
#define  LDAP_LIBEXT  "a"
#define  LDAP_DEFAULT_LOCPATH "/usr/lib/nls/loc"
#define  LDAP_CONFIG_DIR  "/opt/IBM/ldap/V6.0/etc"

#elif defined ( LINUX2 ) || defined (_S390_LINUX_2)
#define  LDAP_CODESET_UTF8 "UTF-8"
#define  LDAP_CODESET_UNICODE "UCS-2"
#define  LDAPHOMEBASE  "/opt/ibm/ldap"
#define  LDAPHOME  "/opt/ibm/ldap/V6.0"
#define  LDAP_LIBEXT  "so"
#define  LDAP_DEFAULT_LOCPATH "/usr/lib/nls/loc"
#define  LDAP_CONFIG_DIR  "/opt/ibm/ldap/V6.0/etc"

#elif defined ( HPUX )
#define  LDAP_CODESET_UTF8 "utf8"
#define  LDAP_CODESET_UNICODE "ucs2"
#define  LDAPHOMEBASE  "/opt/IBM/ldap"
#define  LDAPHOME  "/opt/IBM/ldap/V6.0"
#if defined ( HPUX_IA64 )
#define  LDAP_LIBEXT  "so"
#else
#define  LDAP_LIBEXT  "sl"
#endif
#define  LDAP_DEFAULT_LOCPATH "/usr/lib/nls/loc"
#define  LDAP_CONFIG_DIR  "/opt/IBM/ldap/V6.0/etc"

#elif defined ( __OS400__ )
#define  LDAP_CODESET_UTF8 "UTF-8"
#define  LDAP_CODESET_UNICODE "UCS-2"
    /* TODO: set this and CONFIG_DIR when we know for sure */
#define  LDAPHOME  "/QIBM/ProdData/OS400/DirSrv"
#define  LDAP_LIBEXT  "srvpgm"
#define  LDAP_DEFAULT_LOCPATH "undefined"
#define  LDAP_CONFIG_DIR  "/QIBM/UserData/OS400/DirSrv"

#else
#define  LDAP_CODESET_UTF8 "UTF-8"
#define  LDAP_CODESET_UNICODE "UCS-2"
#define  LDAPHOME  "/opt/ibm/ldap/V6.0"
#define  LDAP_LIBEXT  "a"
#define  LDAP_DEFAULT_LOCPATH "/usr/lib/nls/loc"
#define  LDAP_CONFIG_DIR  "/opt/ibm/ldap/V6.0/etc"

#endif

#include <lber.h>

#define LDAP_URL_PREFIX   "ldap://"
#define LDAPS_URL_PREFIX  "ldaps://"
#define LDAP_CLIENT_REG_PATH            "SOFTWARE\\IBM\\IDSLDAP\\6.0"
#define LDAP_CLIENT_REG_HOME            "LDAPHome"
#define LDAP_SERVICE_NAME  "ldapservicename"

#define LDAP_VERSION2 2
#define LDAP_VERSION3 3
#ifdef LDAPV3
#define LDAP_VERSION LDAP_VERSION3
#else
#define LDAP_VERSION LDAP_VERSION2
#endif

   /* For Server TTL (Time To Live) in Client Cache */
#define LDAP_CACHE_NO_SERVER_TTL 0
#define LDAP_CACHE_SERVER_TTL  1

   /* For compatibility with Netscape & Novell */
   /* to retrieve Information at compile Time */
#define LDAP_SPEC_VERSION 4
#define LDAP_API_VERSION 2000+LDAP_SPEC_VERSION   /* RFC compliance */
#define LDAP_VERSION_MIN 2
#define LDAP_VERSION_MAX 3
#define LDAP_VENDOR_NAME "International Business Machines Corp."
#define LDAP_VENDOR_VERSION 510                      /* LDAP V 4.1   */

#define LDAP_API_INFO_VERSION  1
#define LDAP_FEATURE_INFO_VERSION 1

#ifdef __OS400__
#define LDAP_API_FEATURE_X_MULTI_GSK_ENV 520
#endif

   /* For search attrs */
#define LDAP_ROOT_DSE           ""
#define LDAP_NO_ATTRS           "1.1"
#define LDAP_ALL_USER_ATTRS     "*"

   /* For compatibility w/Netscape implementation of ldap_version(). */
#define LDAP_SECURITY_NONE      0

#define LDAP_PORT 389
#define LDAPS_PORT 636

   /* Define the Ports for the Admin Daemon as registered with IANA */
#define ADMIN_PORT   3538
#define ADMINS_PORT  3539

#define LDAP_NOTICE_OF_DISCONNECTION "1.3.6.1.4.1.1466.20036"
#define LDAP_MAX_ATTR_LEN 400

   /* possible result types a server can return */
#define LDAP_RES_BIND   0x61L /* application + constructed */
#define LDAP_RES_SEARCH_ENTRY  0x64L /* application + constructed */
#define LDAP_RES_SEARCH_RESULT  0x65L /* application + constructed */
#define LDAP_RES_MODIFY   0x67L /* application + constructed */
#define LDAP_RES_ADD   0x69L /* application + constructed */
#define LDAP_RES_DELETE   0x6bL /* application + constructed */
#define LDAP_RES_MODRDN   0x6dL /* application + constructed */
#define LDAP_RES_COMPARE  0x6fL /* application + constructed */
#define LDAP_RES_SEARCH_REFERENCE 0X73L /* application + constructed */
#define LDAP_RES_EXTENDED  0X78L /* application + constructed */
#define LDAP_EXTENDED_RES_NAME  0X8aL /* context specific+primitive*/
#define LDAP_EXTENDED_RES_VALUE  0X8bL /* context specific+primitive*/
#define LDAP_RES_REFERRAL  0Xa3L /* context specific+constructed*/
#define LDAP_RES_ANY   (-1L)
#define LDAP_RES_RENAME   LDAP_RES_MODRDN

   /* authentication methods available */
#define LDAP_AUTH_NONE   0x00L
#define LDAP_AUTH_SIMPLE 0x80L         /* context specific+primitive*/
#define LDAP_AUTH_KRBV41 0x81L
#define LDAP_AUTH_KRBV42 0x82L
#define LDAP_AUTH_KRBV4  0xffL
#define LDAP_AUTH_SASL  0xa3L           /* for alliance support      */
#define LDAP_AUTH_SASL_30 0xa3L
#define LDAP_SASL_SIMPLE ""
#define LDAP_SASL_CRAM_MD5 "CRAM-MD5"
#define LDAP_SASL_EXTERNAL "EXTERNAL"

   /* password policy warning/error results */
#define LDAP_PWDPOLICY_WARNING 0x80L
#define LDAP_PWDPOLICY_ERROR 0x81L
#define LDAP_PWDPOLICY_TIME_WARNING 0x80L
#define LDAP_PWDPOLICY_GRACE_WARNING 0x81L

   /* search scopes */
#define LDAP_SCOPE_BASE  0x00
#define LDAP_SCOPE_ONELEVEL 0x01
#define LDAP_SCOPE_SUBTREE 0x02

   /* ldap_result() all parameter */

#define LDAP_MSG_ONE   0x00
#define LDAP_MSG_ALL  0x01
#define LDAP_MSG_RECEIVED 0x02

   /* bind constants */
#define LDAP_MECHANISM_EXTERNAL    "EXTERNAL"
#define LDAP_MECHANISM_CRAM_MD5    "CRAM-MD5"
#define LDAP_MECHANISM_GSSAPI      "GSSAPI"
#define LDAP_MECHANISM_DIGEST_MD5  "DIGEST-MD5"

   /* for modifications */
   typedef struct ldapmod {
      int mod_op;
#define LDAP_MOD_ADD  0x00
#define LDAP_MOD_DELETE  0x01
#define LDAP_MOD_REPLACE 0x02
#define LDAP_MOD_BVALUES 0x80

      char *mod_type;
      union mod_vals_u {
         char **modv_strvals;
         struct berval **modv_bvals;
      } mod_vals;
#define mod_values mod_vals.modv_strvals
#define mod_bvalues mod_vals.modv_bvals

      struct ldapmod *mod_next;
   }
   LDAPMod;

   /*
    * options that can be set/gotten
    */

#define LDAP_OPT_SIZELIMIT  0x00
#define LDAP_OPT_TIMELIMIT  0x01
#define LDAP_OPT_REFERRALS  0x00000002
#define LDAP_OPT_DEREF   0x03

#define LDAP_OPT_REFHOPLIMIT  0x05
#define LDAP_OPT_DEBUG   0x06

#define LDAP_OPT_SSL_CIPHER  0x07
#define LDAP_OPT_SSL_TIMEOUT  0x08

#define LDAP_OPT_REBIND_FN  0x09
#define LDAP_OPT_SSL   0x0A
#define LDAP_OPT_TLS   0x0B
#define LDAP_OPT_PROTOCOL_VERSION 0x11
#define LDAP_OPT_SERVER_CONTROLS 0x12
#define LDAP_OPT_CLIENT_CONTROLS 0x13
#define LDAP_OPT_API_INFO  0x14
#define LDAP_OPT_API_FEATURE_INFO 0x15
#define LDAP_OPT_HOST_NAME  0x30
#define LDAP_OPT_ERROR_NUMBER  0x31
#define LDAP_OPT_ERROR_STRING  0x32
#define LDAP_OPT_EXT_ERROR              0x33
#define LDAP_OPT_SUPPRESS_CLIENT_AUTH 0x34
#define LDAP_OPT_REFERRAL_HOP_LIMIT 0x35    /* for alliance support      */
#define LDAP_OPT_DELEGATION  0x36
#define LDAP_OPT_EXT_GSS_ERR    0x37
#define LDAP_OPT_CERTIFICATE_SUBJECTALTNAME    0x38
#define LDAP_OPT_CERTIFICATE_COMMON_NAME    0x39

    /* #ifndef __OS400__ */ /* P9A95189 */
#define LDAP_OPT_SSL_CONNECT_CIPHER          0x40
#define LDAP_OPT_SSL_KEYDATABASE     0x41
#define LDAP_OPT_SSL_CLIENT_LABEL    0x42
    /* #endif */

#define LDAP_OPT_SECURE  0x45

#define LDAP_OPT_UTF8_IO   0xE0
#ifdef __OS400__
#define LDAP_OPT_UTF8_XLATE  0xE1
#define LDAP_OPT_LOCALE   0xE2
#endif

#define LDAP_OPT_LCS   0x0F

#define LDAP_X_OPT_GSK_ENV              0x5D20

   /* option value for no size limit or no time limit on searches */
#define LDAP_NO_LIMIT  0

   /* option values for binary options */
#ifndef __64BIT__
#define LDAP_OPT_ON  0x01
#else
#define LDAP_OPT_ON  0x01L
#endif
#define LDAP_OPT_OFF  0x00

   /* option values for utf8 xlates */
#define LDAP_UTF8_XLATE_OFF     0x01
#define LDAP_UTF8_XLATE_ON      0x00

   /* option values for dereferencing aliases */
#define LDAP_DEREF_NEVER  0
#define LDAP_DEREF_SEARCHING 1
#define LDAP_DEREF_FINDING  2
#define LDAP_DEREF_ALWAYS 3

   /* default limit on nesting of referrals */
#define LDAP_DEFAULT_REFHOPLIMIT 10

   /* Debug levels            Old values commented at right */
   /* NOTE: These values MUST MATCH the values in lddebug.h, generated from */
   /*       lddebug.tfi AND LDAP_DEBUG_TRACE should remain FIRST            */
#define LDAP_NUM_DEBUG_LEVELS                19
#ifndef __OS400__
#define LDAP_DEBUG_OFF          0x00000000               /* 0x0000 */
#define LDAP_DEBUG_TRACE                       0xc8010000  /* 0x0001 */
#define LDAP_DEBUG_PACKETS                     0xc8020000  /* 0x0002 */
#define LDAP_DEBUG_ARGS                        0xc8030000  /* 0x0004 */
#define LDAP_DEBUG_CONNS                       0xc8040000  /* 0x0008 */
#define LDAP_DEBUG_XLATE         0xc8050000        /* 0x0009 */
#define LDAP_DEBUG_BER                         0xc8060000  /* 0x0010 */
#define LDAP_DEBUG_FILTER                      0xc8070000  /* 0x0020 */
#define LDAP_DEBUG_MESSAGE                     0xc8080000  /* 0x0040 */
#define LDAP_DEBUG_ACL                         0xc8090000  /* 0x0080 */
#define LDAP_DEBUG_STATS                       0xc80a0000  /* 0x0100 */
#define LDAP_DEBUG_THREAD                      0xc80b0000  /* 0x0200 */
#define LDAP_DEBUG_REPL                        0xc80c0000  /* 0x0400 */
#define LDAP_DEBUG_PARSE                       0xc80d0000  /* 0x0800 */
#define LDAP_DEBUG_PERFORMANCE                 0xc80e0000  /* 0x1000 */
#define LDAP_DEBUG_RDBM                        0xc80f0000  /* 0x2000 */
#define LDAP_DEBUG_REFERRAL                    0xc8100000  /* 0x4000 */
#define LDAP_DEBUG_ERROR                       0xc8110000  /* 0x8000 */
#define LDAP_DEBUG_LD          0xc8120000        /* 0x9000 */
#define LDAP_DEBUG_ANY                         0xc8130000  /* 0xffff */
#else  /* OS400 */
#define LDAP_DEBUG_OFF   0x0000
#define LDAP_DEBUG_TRACE  0x0001
#define LDAP_DEBUG_PACKETS  0x0002
#define LDAP_DEBUG_ARGS   0x0004
#define LDAP_DEBUG_CONNS  0x0008
#define LDAP_DEBUG_BER   0x0010
#define LDAP_DEBUG_XLATE  0x0010    /* Duplicate of BER because there are a limited number of bits to use in ZRU debug */
#define LDAP_DEBUG_FILTER  0x0020
#define LDAP_DEBUG_MESSAGE  0x0040
#define LDAP_DEBUG_ACL   0x0080
#define LDAP_DEBUG_STATS  0x0100
#define LDAP_DEBUG_THREAD  0x0200
#define LDAP_DEBUG_REPL   0x0400
#define LDAP_DEBUG_PARSE  0x0800
#define LDAP_DEBUG_PERFORMANCE  0x1000
#define LDAP_DEBUG_RDBM    0x2000
#define LDAP_DEBUG_REFERRAL   0x4000
#define LDAP_DEBUG_ERROR  0x8000
#define LDAP_DEBUG_ANY   0xffff
#endif


   /* options for SSL ciphers */
#define LDAP_SSL_RC4_MD5_EX "03"
#define LDAP_SSL_RC2_MD5_EX "06"
#define LDAP_SSL_RC4_SHA_US "05"
#define LDAP_SSL_RC4_MD5_US "04"
#define LDAP_SSL_DES_SHA_US "09"
#define LDAP_SSL_3DES_SHA_US "0A"

   /* Server Request Search Source Types */
#define LDAP_LSI_CONF_DNS 0 /* Config first, then DNS (def) */
#define LDAP_LSI_CONF_ONLY 1 /* Configuration file only      */
#define LDAP_LSI_DNS_ONLY 2 /* DNS only                     */

   /* Server Request Connection Types */
#define LDAP_LSI_UDP_TCP 0 /* UDP first, then TCP */
#define LDAP_LSI_UDP  1 /* Use UDP only */
#define LDAP_LSI_TCP  2 /* Use TCP only */

   /* LDAP Server Types */
#define LDAP_LSI_MASTER  1 /* LDAP Master */
#define LDAP_LSI_REPLICA 2 /* LDAP Replica */

   /* LDAP Server Security Types */
#define LDAP_LSI_NOSSL  1 /* Non-SSL */
#define LDAP_LSI_SSL  2 /* Secure Server */

   /*
    * possible error codes we can return
    */

#define LDAP_SUCCESS   0x00
#define LDAP_OPERATIONS_ERROR  0x01
#define LDAP_PROTOCOL_ERROR  0x02
#define LDAP_TIMELIMIT_EXCEEDED  0x03
#define LDAP_SIZELIMIT_EXCEEDED  0x04
#define LDAP_COMPARE_FALSE  0x05
#define LDAP_COMPARE_TRUE  0x06
#define LDAP_AUTH_METHOD_NOT_SUPPORTED 0x07    /* for alliance support      */
#define LDAP_STRONG_AUTH_NOT_SUPPORTED 0x07
#define LDAP_STRONG_AUTH_REQUIRED 0x08
#define LDAP_PARTIAL_RESULTS  0x09

#define LDAP_REFERRAL   0X0a
#define LDAP_ADMINLIMIT_EXCEEDED 0X0b    /* for alliance support      */
#define LDAP_ADMIN_LIMIT_EXCEEDED 0X0b
#define LDAP_UNAVAILABLE_CRITICAL_EXTENSION  0X0c
#define LDAP_CONFIDENTIALITY_REQUIRED   0x0d
#define LDAP_SASL_BIND_IN_PROGRESS      0x0e    /* for alliance support      */
#define LDAP_SASLBIND_IN_PROGRESS       0x0e

#define LDAP_NO_SUCH_ATTRIBUTE  0x10
#define LDAP_UNDEFINED_TYPE  0x11
#define LDAP_INAPPROPRIATE_MATCHING 0x12
#define LDAP_CONSTRAINT_VIOLATION 0x13
#define LDAP_TYPE_OR_VALUE_EXISTS 0x14
#define LDAP_INVALID_SYNTAX  0x15

#define LDAP_NO_SUCH_OBJECT  0x20
#define LDAP_ALIAS_PROBLEM  0x21
#define LDAP_INVALID_DN_SYNTAX  0x22
#define LDAP_IS_LEAF   0x23
#define LDAP_ALIAS_DEREF_PROBLEM 0x24

#define LDAP_INAPPROPRIATE_AUTH  0x30
#define LDAP_INVALID_CREDENTIALS 0x31
#define LDAP_INSUFFICIENT_ACCESS 0x32
#define LDAP_BUSY   0x33
#define LDAP_UNAVAILABLE  0x34
#define LDAP_UNWILLING_TO_PERFORM 0x35
#define LDAP_LOOP_DETECT  0x36

#define LDAP_NAMING_VIOLATION  0x40
#define LDAP_OBJECT_CLASS_VIOLATION 0x41
#define LDAP_NOT_ALLOWED_ON_NONLEAF 0x42
#define LDAP_NOT_ALLOWED_ON_RDN  0x43
#define LDAP_ALREADY_EXISTS  0x44
#define LDAP_NO_OBJECT_CLASS_MODS 0x45
#define LDAP_RESULTS_TOO_LARGE  0x46

#define LDAP_AFFECTS_MULTIPLE_DSAS 0X47

#define LDAP_OTHER   0x50
#define LDAP_SERVER_DOWN  0x51
#define LDAP_LOCAL_ERROR  0x52
#define LDAP_ENCODING_ERROR  0x53
#define LDAP_DECODING_ERROR  0x54
#define LDAP_TIMEOUT   0x55
#define LDAP_AUTH_UNKNOWN  0x56
#define LDAP_FILTER_ERROR  0x57
#define LDAP_USER_CANCELLED  0x58
#define LDAP_PARAM_ERROR  0x59
#define LDAP_NO_MEMORY   0x5a
#define LDAP_CONNECT_ERROR  0x5b
#define LDAP_NOT_SUPPORTED  0x5c
#define LDAP_CONTROL_NOT_FOUND  0x5d
#define LDAP_NO_RESULTS_RETURNED 0x5e
#define LDAP_MORE_RESULTS_TO_RETURN 0x5f

#define LDAP_URL_ERR_NOTLDAP  0x60
#define LDAP_URL_ERR_NODN  0x61
#define LDAP_URL_ERR_BADSCOPE  0x62
#define LDAP_URL_ERR_MEM  0x63

#define LDAP_CLIENT_LOOP  0x64
#define LDAP_REFERRAL_LIMIT_EXCEEDED 0x65

#define LDAP_SSL_ALREADY_INITIALIZED    0x70
#define LDAP_SSL_INITIALIZE_FAILED      0x71
#define LDAP_SSL_CLIENT_INIT_NOT_CALLED 0x72
#define LDAP_SSL_PARAM_ERROR            0x73
#define LDAP_SSL_HANDSHAKE_FAILED       0x74
#define LDAP_SSL_GET_CIPHER_FAILED      0x75
#define LDAP_SSL_NOT_AVAILABLE          0x76
#define LDAP_SSL_KEYRING_NOT_FOUND      0x77
#define LDAP_SSL_PASSWORD_NOT_SPECIFIED 0x78

   /* TLS version of the error codes */
#define LDAP_TLS_ALREADY_INITIALIZED    LDAP_SSL_ALREADY_INITIALIZED
#define LDAP_TLS_INITIALIZE_FAILED      LDAP_SSL_INITIALIZE_FAILED
#define LDAP_TLS_CLIENT_INIT_NOT_CALLED LDAP_SSL_CLIENT_INIT_NOT_CALLED
#define LDAP_TLS_PARAM_ERROR            LDAP_SSL_PARAM_ERROR
#define LDAP_TLS_HANDSHAKE_FAILED       LDAP_SSL_HANDSHAKE_FAILED
#define LDAP_TLS_GET_CIPHER_FAILED      LDAP_SSL_GET_CIPHER_FAILED
#define LDAP_TLS_NOT_AVAILABLE          LDAP_SSL_NOT_AVAILABLE
#define LDAP_TLS_KEYRING_NOT_FOUND      LDAP_SSL_KEYRING_NOT_FOUND
#define LDAP_TLS_PASSWORD_NOT_SPECIFIED LDAP_SSL_PASSWORD_NOT_SPECIFIED

#define LDAP_NO_EXPLICIT_OWNER  0x80
#define LDAP_NO_LOCK   0x81

   /* DNS related error codes */
#define LDAP_DNS_NO_SERVERS  0x85 /* No LDAP servers found */
#define LDAP_DNS_TRUNCATED  0x86 /* Warning: truncated DNS results */
#define LDAP_DNS_INVALID_DATA  0x87 /* Invalid DNS Data */
#define LDAP_DNS_RESOLVE_ERROR  0x88 /* Can't resolve system domain or nameserver */
#define LDAP_DNS_CONF_FILE_ERROR 0x89 /* DNS Configuration file error */

   /* UTF8 related error codes */
#define LDAP_XLATE_E2BIG  0xA0 /* Output buffer overflow */
#define LDAP_XLATE_EINVAL  0xA1 /* Input buffer truncated */
#define LDAP_XLATE_EILSEQ  0xA2 /* Unusable input character */
#define LDAP_XLATE_NO_ENTRY  0xA3    /* No codeset point to map to */

#define LDAP_REG_FILE_NOT_FOUND  0xB0 /* NT Registry - file not found */
#define LDAP_REG_CANNOT_OPEN  0xB1 /* NT Registry - can not open */
#define LDAP_REG_ENTRY_NOT_FOUND 0xB2 /* NT Registry entry not found */

#define LDAP_CONF_FILE_NOT_OPENED  0xC0 /* Plugin configuration file not opened */
#define LDAP_PLUGIN_NOT_LOADED   0xC1 /* Plugin library not loaded */
#define LDAP_PLUGIN_FUNCTION_NOT_RESOLVED 0xC2 /* Plugin function not resolved */
#define LDAP_PLUGIN_NOT_INITIALIZED  0xC3 /* Plugin library not initialized */
#define LDAP_PLUGIN_COULD_NOT_BIND              0xC4    /* Plugin function could not bind */

#define LDAP_SASL_GSS_NO_SEC_CONTEXT  0xD0 /* gss_init_sec_context failed */

#define LDAP_PWD_ERROR_START 0x03
#define LDAP_TIME_BEFORE_EXPIRE  0x01
#define LDAP_GRACE_LOGINS   0x02
#define LDAP_PASSWORD_EXPIRED  0x03
#define LDAP_ACCOUNT_LOCKED   0x04
#define LDAP_CHANGE_AFTER_RESET  0x05
#define LDAP_PASSWORD_NO_MOD  0x06
#define LDAP_NEED_OLD_PASSWORD  0x07
#define LDAP_INVALID_PASS_SYNTAX 0x08
#define LDAP_PASSWORD_TOO_SHORT  0x09
#define LDAP_PASSWORD_TOO_YOUNG  0x0A
#define LDAP_PASSWORD_IN_HISTORY 0x0B

   /* oid for ManageDseIt oid to stop referral */
#define LDAP_MANAGEDSAIT_OID "2.16.840.1.113730.3.4.2"

   /* oids related to transaction support */
#define LDAP_START_TRANSACTION_OID    "1.3.18.0.2.12.5"
#define LDAP_END_TRANSACTION_OID      "1.3.18.0.2.12.6"
#define LDAP_PREPARE_TRANSACTION_OID   "1.3.18.0.2.12.64" 
#define LDAP_TRANSACTION_CONTROL_OID "1.3.18.0.2.10.5"

   /* oids for event notification support */
#define LDAP_EVENT_REGISTER_OID "1.3.18.0.2.12.1"
#define LDAP_EVENT_UNREGISTER_OID "1.3.18.0.2.12.3"

   /* oids for ldap_delete_ext and ldap_delete_ext_s when */
   /* deleting a projected user (DLTUSRPF) on OS/400.     */
#define LDAP_OS400_OWNOBJOPT_CONTROL_OID "1.3.18.0.2.10.8"
#define LDAP_OS400_PGPOPT_CONTROL_OID "1.3.18.0.2.10.9"

   /* oid for sorted search and paged results oid */
#define LDAP_SORTED_SEARCH_REQ_OID "1.2.840.113556.1.4.473"
#define LDAP_SORTED_SEARCH_RES_OID "1.2.840.113556.1.4.474"
#define LDAP_PAGED_RESULTS_OID "1.2.840.113556.1.4.319"

   /*oid for audit control*/
#define LDAP_AUDIT_CONTROL_OID "1.3.18.0.2.10.22"

   /*oid for group authorization control*/
#define LDAP_GROUP_AUTH_CONTROL_OID "1.3.18.0.2.10.21"

   /* oid for starting and stopping the server through the admin daemon */
#define LDAP_ADMIN_SLAPD   "1.3.18.0.2.12.26"
#define LDAP_ADMIN_SLAPD_RESP "1.3.18.0.2.12.27"

   /* oid for startTLS operation */
#define LDAP_STARTTLS_OID   "1.3.6.1.4.1.1466.20037"

   /* oids for log access support */
#define LDAP_LOG_NUMLINES_REQ_OID "1.3.18.0.2.12.24"
#define LDAP_LOG_NUMLINES_RES_OID "1.3.18.0.2.12.25"
#define LDAP_LOG_GETLINES_REQ_OID "1.3.18.0.2.12.22"
#define LDAP_LOG_GETLINES_RES_OID "1.3.18.0.2.12.23"
#define LDAP_LOG_CLEAR_REQ_OID "1.3.18.0.2.12.20"
#define LDAP_LOG_CLEAR_RES_OID "1.3.18.0.2.12.21"

   /* oids for replication extended operations */
#define LDAP_REPL_CASC_CONTROL_REQ_OID "1.3.18.0.2.12.15"
#define LDAP_REPL_CONTROL_REPL_REQ_OID "1.3.18.0.2.12.16"
#define LDAP_REPL_CONTROL_QUEUE_REQ_OID "1.3.18.0.2.12.17"
#define LDAP_REPL_QUIESCE_REQ_OID "1.3.18.0.2.12.19"
#define LDAP_REPL_TOPOLOGY_REQ_OID "1.3.18.0.2.12.54"
#define LDAP_REPL_TOPOLOGY_RES_OID "1.3.18.0.2.12.55"

   /* control for replication topology extended operation */
#define LDAP_REPL_DO_NOT_REPLICATE_CONTROL_OID "1.3.18.0.2.10.23"
   /* control for replication conflict resolution */
#define LDAP_REPL_REFRESH_ENTRY_CONTROL_OID "1.3.18.0.2.10.24"
   /* control for skip replication conflict resolution */
#define LDAP_REPL_NO_CONFLICT_RESOLUTION_CONTROL_OID "1.3.18.0.2.10.27"

   /* oid for password policy */
#define LDAP_PWDPOLICY_CONTROL_OID "1.3.6.1.4.1.42.2.27.8.5.1"

/* oid for operational attribute replication */
#define LDAP_REPL_OP_ATTRIBS_OID "1.3.18.0.2.10.19"

   /* oid for server administration control */
#define LDAP_SERVER_ADMIN_CONTROL_OID "1.3.18.0.2.10.15"

   /* oid for gateway forwarding supplier id control */
#define LDAP_REPL_SUPPLIER_BIND_CONTROL_OID "1.3.18.0.2.10.18"

   /* oid for supplier and change id control */
#define LDAP_REPL_UPDATE_ID_OID "1.3.18.0.2.10.29"

/* OID for AES authorization bind control */
#define LDAP_AES_BIND_CONTROL_OID "1.3.18.0.2.10.28"

/* oid for proxied authorization support */
#define  LDAP_PROXY_CONTROL_OID "2.16.840.1.113730.3.4.18"


   /* oids for update Config support*/
#define LDAP_CONFIG_UPDATE_REQ_OID "1.3.18.0.2.12.28"
#define LDAP_CONFIG_UPDATE_RES_OID "1.3.18.0.2.12.29"
#define LDAP_LOG_ACCESS_UPDATE_OID "1.3.18.0.2.12.32"
#define LDAP_EVENT_UPDATE_OID "1.3.18.0.2.12.31"

   /*oids for DN normalize plugin*/
#define LDAP_DN_NORMALIZE_OID "1.3.18.0.2.12.30"

/*oid for unbind of a bound DN/IP*/
#define LDAP_DN_UNBIND_REQ_OID "1.3.18.0.2.12.35"
#define LDAP_DN_UNBIND_RES_OID "1.3.18.0.2.12.36"

/*oids for group evaluation extended operation*/
#define LDAP_GROUP_EVAL_REQ_OID "1.3.18.0.2.12.50"
#define LDAP_GROUP_EVAL_RES_OID "1.3.18.0.2.12.52"

    /*oids for locate entry extended operation*/
#define LDAP_LOCATE_ENTRY_REQ_OID "1.3.18.0.2.12.71"
#define LDAP_LOCATE_ENTRY_RES_OID "1.3.18.0.2.12.72"
/*oids for account status extended operation*/
#define LDAP_ACCT_STATUS_REQ_OID "1.3.18.0.2.12.58"
#define LDAP_ACCT_STATUS_RES_OID "1.3.18.0.2.12.59"

   /* Enumeration that specifies the response integers
      that will be returned on an account status request
      extended operation.*/
   typedef enum AcctStatusEnum {
      ACCOUNT_OPEN    = 0,
      ACCOUNT_LOCKED  = 1,
      ACCOUNT_EXPIRED = 2
   } AcctStatusEnum;

/* oids for group referential integrity controls */
#define LDAP_MODIFY_GROUPS_ONLY_CONTROL_OID "1.3.18.0.2.10.25"
#define LDAP_OMIT_GROUP_REF_INTEGRITY_CONTROL_OID "1.3.18.0.2.10.26"

   /* oid for delete subtree oid */
#define LDAP_DELETE_SUBTREE_CONTROL_OID "1.2.840.113556.1.4.805"
   /* symbol as defined by Microsoft in winldap.h */
#define LDAP_SERVER_TREE_DELETE_OID "1.2.840.113556.1.4.805"

    /*OID for Resume Role Extended Operation*/
#define LDAP_RESUME_ROLE_REQ_OID "1.3.18.0.2.12.65"
   /* OIDs for capabilities */
#define LDAP_ENHANCED_REPLICATION_OID "1.3.18.0.2.32.1"
#define LDAP_ENTRY_CHECKSUM_OID       "1.3.18.0.2.32.2"
#define LDAP_IBM_ENTRYUUID_OID        "1.3.18.0.2.32.3"
#define LDAP_FILTER_ACL_OID           "1.3.18.0.2.32.4"
#define LDAP_PASSWORD_POLICY_OID      "1.3.18.0.2.32.5"
#define LDAP_SORT_BY_DN_OID           "1.3.18.0.2.32.6"
#define LDAP_ADMIN_GROUP_DEL_OID      "1.3.18.0.2.32.8"
#define LDAP_DOS_PREVENTION_OID       "1.3.18.0.2.32.9"
#define LDAP_DEREF_ALIASES_OID        "1.3.18.0.2.32.10"
#define LDAP_ADMIN_AUDIT_OID          "1.3.18.0.2.32.11"
#define LDAP_ATTRIBUTE_CACHE_OID      "1.3.18.0.2.32.13"
#define LDAP_ENHANCED_DYN_UPDATE_OID  "1.3.18.0.2.32.15"
#define LDAP_UNIQUE_ATTRIBUTES_OID    "1.3.18.0.2.32.16"
#define LDAP_GROUP_SEARCH_LIMITS_OID  "1.3.18.0.2.32.17"
#define LDAP_IBM_POLICIES_OID         "1.3.18.0.2.32.18"
#define LDAP_CHANGE_LOG_MAX_AGE_OID   "1.3.18.0.2.32.19"
#define LDAP_NULL_BASED_SUB_SEARCH_OID "1.3.18.0.2.32.26"
#define LDAP_PROXY_AUTHORIZATION_OID  "1.3.18.0.2.32.27"
#define LDAP_TLS_SUPPORT_OID          "1.3.18.0.2.32.28"
#define LDAP_NON_BLOCKING_REPLICATION_CAPABILITY_OID  "1.3.18.0.2.32.29"
#define LDAP_KERBEROS_SUPPORT_OID     "1.3.18.0.2.32.30"
#define LDAP_DYNAMIC_GROUPS_OID       "1.3.18.0.2.32.31"
#define LDAP_SSL_FIPS_MODE_CAPABILITY_OID  "1.3.18.0.2.32.32"
#define LDAP_ATTRIBUTE_CACHE_AUTO_ADJUST_OID "1.3.18.0.2.32.50"
#define LDAP_SSL_FIPS_PROCESSING_MODE_CAPABILITY_OID  "1.3.18.0.2.32.55"
#define LDAP_MODIFYDN_LEAF_CAPABILITY_OID  "1.3.18.0.2.32.35"
#define LDAP_FILTERED_REFERRALS_CAPABILITY_OID "1.3.18.0.2.32.36"
#define LDAP_GLOBAL_ADMIN_GROUP_OID   "1.3.18.0.2.32.38"
#define LDAP_AUDIT_COMPARE_CAPABILITY_OID "1.3.18.0.2.32.40"
#define LDAP_MULTIHOMED_CAPABILITY_OID "1.3.18.0.2.32.45"
#define LDAP_MULTIPLE_INSTANCES_ARCH_CAPABILITY_OID "1.3.18.0.2.32.46"
#define LDAP_CONFIG_TOOLS_LOG_CAPABILITY_OID "1.3.18.0.2.32.47"
#define LDAP_PROXY_SERVER_CAPABILITY_OID "1.3.18.0.2.32.49"
#define LDAP_LANGUAGE_TAG_OID         "1.3.6.1.4.1.4203.1.5.4"
#define LDAP_LOG_MANAGEMENT_OID       "1.3.18.0.2.32.41"
#define LDAP_AUDIT_CONFIGURATION_SETTINGS_CONSOLIDATION_OID   "1.3.18.0.2.32.48"
#define LDAP_REPL_CONFLICT_MAX_ENTRY_SIZE_OID   "1.3.18.0.2.32.51"
#define LDAP_LOSTANDFOUND_LOG_OID   "1.3.18.0.2.32.52"
    /* Password Encryption Method OIDS */
#define LDAP_AES_PWD_ENCRYPTION_OID "1.3.18.0.2.32.39"
#define LDAP_SSHA_PWD_ENCRYPTION_OID   "1.3.18.0.2.32.63"
    /* V6.0 Admin Password Policy OIDS */
#define LDAP_ADMIN_PASSWORD_POLICY_OID      "1.3.18.0.2.32.53"
#define LDAP_PASSWORD_POLICY_ACCOUNT_LOCKED_OID      "1.3.18.0.2.32.54"
#define LDAP_LONG_TABLE_NAMES_OID "1.3.18.0.2.32.12" 
#define LDAP_SIMPLIFY_RESIZING_ATTRIBUTES_OID "1.3.18.0.2.32.37"

    /* V6.0 Replication OIDs */
#define LDAP_SUPPLIER_REPL_CONFIG_CAPABILITY_OID      "1.3.18.0.2.32.43"
#define LDAP_MULTITHREADED_REPLICATION_CAPABILITY_OID "1.3.18.0.2.32.42"
#define LDAP_IBMPOLICIES_REPLICATION_CAPABILITY_OID   "1.3.18.0.2.32.44"
#define LDAP_REPL_ERROR_LOG_CONTROL_REQUEST_OID       "1.3.18.0.2.12.56"
#define LDAP_REPL_ERROR_LOG_CONTROL_RESPONSE_OID      "1.3.18.0.2.12.57"
#define LDAP_ENHANCED_ENTRY_CHECKSUM_OP_OID 	      "1.3.18.0.2.32.56"

#define LDAP_ENHANCED_TRANSACTION_OID                 "1.3.18.0.2.32.58"
#define LDAP_PROXY_MONITOR_SEARCH_OID                 "1.3.18.0.2.32.61"

    /* V6.1 Password Policy Start Time OID */
#define LDAP_PASSWORD_GLOBAL_START_TIME_OID           "1.3.18.0.2.32.57"
typedef enum ldap_repl_error_log_option {
  LDAP_REPL_ERROR_LOG_UNSET   = 0,
  LDAP_REPL_ERROR_LOG_RETRY   = 1,
  LDAP_REPL_ERROR_LOG_SHOW    = 2,
  LDAP_REPL_ERROR_LOG_DELETE  = 3,
  LDAP_REPL_ERROR_LOG_NUM_OPTIONS
} LDAP_REPL_ERROR_LOG_OPTION;


/* OIDS for all of the different ACL models we support */
#define LDAP_IBM_ACL_OID               "1.3.18.0.2.26.2"
#define LDAP_FILTERED_ACL_OID          "1.3.18.0.2.26.3"
#define LDAP_SYSTEM_RESTRICTED_ACL_OID "1.3.18.0.2.26.4"

/* OIDS for Monitor */
#define LDAP_MONITOR_OPERATION_COUNTS  "1.3.18.0.2.32.24"
#define LDAP_MONITOR_LOGGING_COUNTS    "1.3.18.0.2.32.20"
#define LDAP_MONITOR_CONN_TYPE_COUNTS  "1.3.18.0.2.32.22"
#define LDAP_MONITOR_ACTIVE_WORKERS    "1.3.18.0.2.32.21"
#define LDAP_MONITOR_CONNECTIONS_IP    "1.3.18.0.2.32.23"
#define LDAP_MONITOR_TRACING           "1.3.18.0.2.32.25"

/* OIDS for the Unique Attributes Extended Operation plugin */
#define LDAP_UNIQUE_ATTR_REQ_OID "1.3.18.0.2.12.44"
#define LDAP_UNIQUE_ATTR_RES_OID "1.3.18.0.2.12.45"


   /* OIDs for DIGEST-MD5 SASL bind mechanism */
#define IBM_CLIENT_DIGEST_REALM_NAME_OID "1.3.18.0.2.10.12"
#define IBM_CLIENT_MD5_REALM_NAME_OID IBM_CLIENT_DIGEST_REALM_NAME_OID
#define IBM_CLIENT_DIGEST_USER_NAME_OID "1.3.18.0.2.10.13"
#define IBM_CLIENT_MD5_USER_NAME_OID IBM_CLIENT_DIGEST_USER_NAME_OID

/* OIDS for the User Type Extended Operation plugin */
#define LDAP_ATTR_TYPE_REQ_OID "1.3.18.0.2.12.46"
#define LDAP_ATTR_TYPE_RES_OID "1.3.18.0.2.12.47"

   /* Enumeration that specifies the request integers
      that can be sent through for the attribute type
      requests on the attribute type extended operation.*/
   typedef enum AttrTypeEnum {
      OPERATIONAL = 0,
      LANGUAGE_TAG = 1,
      ATTRIBUTE_CACHE = 2,
      UNIQUE_ATTR = 3,
      CONFIGURATION = 4
   } AttrTypeEnum;

/* OIDS for the User Type Extended Operation plugin */
#define LDAP_USER_TYPE_REQ_OID "1.3.18.0.2.12.37"
#define LDAP_USER_TYPE_RES_OID "1.3.18.0.2.12.38"

/* The user types that can be returned from the user type
   extended operation */
#define ROOT_ADMIN_USERTYPE "root_administrator"
#define ADMIN_GROUP_MEMBER_USERTYPE "admin_group_member"
#define LOCAL_OS_USERTYPE "local_os_user"
#define LDAP_USER_USERTYPE "ldap_user_type"
#define GLOBAL_ADMIN_GROUP_MEMBER_USERTYPE "global_admin_group_member"

/* The user roles that can be returned from the user type
   extended operation */
#define SERVER_CONFIG_ADMIN_USERROLE "server_config_administrator"
#define SERVER_CONFIG_GROUP_MEMBER_USERROLE "server_config_group_member"
#define SERVER_CONFIG_GROUP_READONLY_USERROLE "server_config_read_only"
#define DIRECTORY_ADMIN_USERROLE "directory_administrator"
#define LDAP_USER_USERROLE "ldap_user_role"


   /* Persistent search OID and client API parameters */
#define LDAP_CHANGETYPE_ADD             1
#define LDAP_CHANGETYPE_DELETE          2
#define LDAP_CHANGETYPE_MODIFY          4
#define LDAP_CHANGETYPE_MODDN           8
#define LDAP_CHANGETYPE_ANY             (1|2|4|8)

   
#define LDAP_CONTROL_PERSISTENTSEARCH   "2.16.840.1.113730.3.4.3"
#define LDAP_CONTROL_ENTRYCHANGE        "2.16.840.1.113730.3.4.7"
   /* end persistent search */


   /* Enumeration that specifies the request integers
      that can be sent through the dynamic configuration
      extended operation.*/
   typedef enum dynamicConfigEnum {
      ALL = 0,
      ATTRIBUTE = 1,
      ENTRY = 2,
      SUBTREE = 3
   } dynamicConfigEnum;

   typedef enum adminEnum {
      START = 0,
      STOP = 1,
      RESTART = 2,
      STATUS = 3,
      ADMSTOP = 4
   } adminEnum;

   typedef enum serverStat {
      STARTED = 0,
      STARTING = 1,
      STOPPED = 2
   } serverStat;

   typedef enum _logType { SlapdErrors = 1,
                           CLIErrors = 2,
                           AuditLog = 4,
                           BulkloadLog = 8,
                           AdminErrors = 16,
                           AdminAudit = 32, 
			   DebugOutputFile = 64, /* Dynamic Trace */
			   LostAndFoundLog = 128, 
			   ConfigToolsLog = 256 
                          } logType;
    /* Enumeration that specifies the request integers
       that can be sent through the resume role 
       extended operation.*/
    typedef enum resumeRoleEnum {
        RES_ALL = 0,
        RES_PARTITION = 1,
        RES_SERVER = 2,
        RES_SERVERINAPARTITION = 3
    } resumeRoleEnum;

    /* Dynamic Trace OIDs */
#define LDAP_DYNAMIC_TRACE_CAPABILITY_OID "1.3.18.0.2.32.14"
#define LDAP_DYNAMIC_TRACE_REQUEST_OID    "1.3.18.0.2.12.40"
#define LDAP_DYNAMIC_TRACE_RESPONSE_OID   "1.3.18.0.2.12.42"
#define LDAP_TRACE_FACILITY_REQUEST_OID   "1.3.18.0.2.12.41"
#define LDAP_TRACE_FACILITY_RESPONSE_OID  "1.3.18.0.2.12.43"

    /* Dynamic Trace typedefs */
typedef enum _ldtrc_options {
    LDTRC_ON = 1,
    LDTRC_OFF,
    LDTRC_CHG,
    LDTRC_CLR,
    LDTRC_INFO,
    LDTRC_DUMP,
    LDTRC_NUM_OPTIONS = 6
} ldtrc_options;
    
    /* Dynamic Trace macros */
#define LDTRC_PROGRAM_NAME "ldtrc"
#define LDTRC_COMMAND_ON   "on"
#define LDTRC_COMMAND_OFF  "off"
#define LDTRC_COMMAND_CLR  "clr"
#define LDTRC_COMMAND_CHG  "chg"
#define LDTRC_COMMAND_INFO "info"
#define LDTRC_COMMAND_DUMP "dump"

   /*
    * These options are used with the LDAP_REPL_CASC_CONTROL_REQ_OID
    * extended operation.
    */
#define LDAP_REPL_CASCADE_QUIESCE                     0
#define LDAP_REPL_CASCADE_UNQUIESCE                   1
#define LDAP_REPL_CASCADE_REPLICATE_NOW               2
#define LDAP_REPL_CASCADE_WAIT_FOR_REPLICATION        3

   /*
    * These options are used with the LDAP_REPL_CONTROL_REPL_REQ_OID
    * extended operation.
    */
#define LDAP_REPL_CONTROL_REPL_ACTION_SUSPEND         0
#define LDAP_REPL_CONTROL_REPL_ACTION_RESUME          1
#define LDAP_REPL_CONTROL_REPL_ACTION_REPLICATENOW    2
#define LDAP_REPL_CONTROL_REPL_SCOPE_SINGLE_AGREEMENT 0
#define LDAP_REPL_CONTROL_REPL_SCOPE_ALL_AGREEMENTS   1

   /*
    * These options are used with the LDAP_REPL_CONTROL_QUEUE_REQ_OID
    * extended operation.
    */
#define LDAP_REPL_QUEUE_SKIPALL                       0
#define LDAP_REPL_QUEUE_SKIPSINGLE                    1

   /*
    * Result codes unique to the LDAP_REPL_QUIESCE_REQ_OID
    * extended operation.
    */
#define LDAP_REPL_QUIESCE_BAD_STATE                   0x101

   /*
    * This structure represents both ldap messages and ldap responses.
    * These are really the same, except in the case of search responses,
    * where a response has multiple messages.
   */

   typedef struct ldapmsg LDAPMessage;
#define NULLMSG ((LDAPMessage *) NULL)

   /*
    * structure representing an ldap connection
    */

   typedef struct ldap LDAP;
   typedef struct ldap_pblock LDAP_Pblock;

   /*
    * structure for ldap_set_rebind_proc()
    */

   typedef int (*LDAPRebindProc)( struct ldap *ld, char **dnp,
                                  char **passwdp, int *authmethodp, int freeit );

   /*
    * structure for retrieving information during execution
    */

   typedef struct ldapapiinfo {
      int ldapai_info_version;
      int ldapai_api_version;
      int ldapai_protocol_version;
      char **ldapai_extensions;
      const char *ldapai_vendor_name;
      int ldapai_vendor_version;
   }
   LDAPAPIInfo;

   typedef struct ldap_apifeature_info {
      int ldapaif_info_version;
      char *ldapaif_name;
      int ldapaif_version;
   }
   LDAPAPIFeatureInfo;

   /*
    * structure for ldap friendly mapping routines
    */

   typedef struct friendly {
      char *f_unfriendly;
      char *f_friendly;
   }
   FriendlyMap;

   /*
    * structure for ldap URL extension
    */

   typedef struct ldap_url_ext {
      char *lue_type;
      char *lue_value;
      int lue_is_critical;
   }
   LDAPURLEXT;

   /*
    * structure for ldap URL handling
    */

   typedef struct ldap_url_desc {
      char *lud_scheme;
      char *lud_host;
      int lud_port;
      char *lud_dn;
      char ** lud_attrs;
      int lud_scope;
      char *lud_filter;
      char *lud_string; /* for internal use only */
   }
   LDAPURLDesc;
#define NULLLDAPURLDESC ((LDAPURLDesc *)NULL)

   /*
    * structure for LDAP version
    */

   typedef struct _LDAPVersion {
      int sdk_version;
      int protocol_version;
      int SSL_version;
      int security_level;
      char ssl_max_cipher[ 65 ] ;
      char *sdk_vendor;
      const char *sdk_build_level;
      char reserved[ 57 ] ;
   }
   LDAPVersion;

   /*
    * structure for LDAP control
    */

   typedef struct _LDAPControl {
      char *ldctl_oid;
      struct berval ldctl_value;
      int ldctl_iscritical;
   }
   LDAPControl;

   /*
    * structure for LDAP Server Request
    */

   typedef struct LDAP_Server_Request {
      int search_source;   /* Search DNS, Cache or both */
      char *conf_filename;   /* Configuration file */
      int reserved;   /* Reserved, set to 0 */
      char *service_key;   /* Service identifier */
      char *enetwork_domain;  /* eNetwork domain name */
      char **name_servers;   /* Array of name servers */
      char **dns_domains;   /* Array of DNS domains */
      int connection_type;  /* Use UDP, TCP or both */
      int connection_timeout;  /* Connection timeout in seconds */
      char *DN_filter;   /* DN suffix filter */
      char *proto_key;   /* Symbolic protocol name */
      unsigned char reserved2[60]; /* Reserved, set to 0 */
   }
   LDAPServerRequest;

   /*
    * structure for LDAP Server Information
    */

   typedef struct LDAP_Server_Info {
      char *lsi_host;   /* LDAP server hostname */
      unsigned short lsi_port;  /* LDAP server port  */
      char *lsi_suffix;   /* server suffix */
      char *lsi_query_key;   /* service_key[.enetwork_domain] */
      char *lsi_dns_domain;  /* publishing DNS domain */
      int lsi_replica_type;  /* master or replica */
      int lsi_sec_type;   /* SSL or non-SSL */
      unsigned short lsi_priority;  /* server priority */
      unsigned short lsi_weight;  /* load balancing weight */
      char *lsi_vendor_info;  /* vendor information    */
      char *lsi_info;   /* LDAP info string */
      struct LDAP_Server_Info *prev;  /* linked list previous pointer */
      struct LDAP_Server_Info *next;  /* linked lsit next pointer */
   }
   LDAPServerInfo;

   /* Function prototypes */
#ifndef _NO_PROTO
#define LDAP_P(x) x
#else
#define LDAP_P(x) ()
#endif

#ifndef LDAPFUNCDECL
#ifdef _WIN32
#define LDAPFUNCDECL __declspec( dllexport )
#else /* _WIN32 */
#define LDAPFUNCDECL
#endif /* _WIN32 */
#endif /* LDAPFUNCDECL */

   /* Hash functions */
   int get_hash_value( const char * str, int numPartitions );
   int get_hash_value_from_dn( const char * dn, const char * base,
                               int numPartitions );

   /* LDAP Abandon functions */
   int ldap_abandon LDAP_P(( LDAP *ld, int msgid ));
   int ldap_abandon_ext LDAP_P(( LDAP *ld, int msgid,
                                 LDAPControl **serverctrls,
                                 LDAPControl **clientctrls));

   /* LDAP Add functions */
   int ldap_add LDAP_P(( LDAP *ld, const char *dn, LDAPMod **attrs ));
   int ldap_add_s LDAP_P(( LDAP *ld, const char *dn, LDAPMod **attrs ));
   int ldap_add_ext LDAP_P((LDAP *ld, const char *dn, LDAPMod **attrs,
                            LDAPControl **serverctrls,
                            LDAPControl **clientctrls,
                            int *msgidp));
   int ldap_add_ext_s LDAP_P((LDAP *ld, const char *dn, LDAPMod **attrs,
                              LDAPControl **serverctrls,
                              LDAPControl **clientctrls));

   /* LDAP Bind functions */
   int ldap_bind LDAP_P(( LDAP *ld, const char *who, const char *passwd,
                          int authmethod ));
   int ldap_bind_s LDAP_P(( LDAP *ld, const char *who, const char *cred,
                            int method ));
   int ldap_simple_bind LDAP_P(( LDAP *ld, const char *who,
                                 const char *passwd ));
   int ldap_simple_bind_s LDAP_P(( LDAP *ld, const char *who,
                                   const char *passwd ));
   void ldap_set_rebind_proc LDAP_P(( LDAP *ld,
                                      LDAPRebindProc rebindproc ));

   /* LDAP Compare functions */
   int ldap_compare LDAP_P(( LDAP *ld, const char *dn, const char *attr,
                             const char *value ));
   int ldap_compare_s LDAP_P(( LDAP *ld, const char *dn, const char *attr,
                               const char *value ));
   int ldap_compare_ext LDAP_P(( LDAP *ld, const char *dn, const char *attr,
                                 const struct berval *bvalue,
                                 LDAPControl **serverctrls,
                                 LDAPControl **clientctrls,
                                 int *msgidp));
   int ldap_compare_ext_s LDAP_P(( LDAP *ld, const char *dn, const char *attr,
                                   const struct berval *bvalue,
                                   LDAPControl **serverctrls,
                                   LDAPControl **clientctrls));

   /* LDAP Delete functions */
   int ldap_delete LDAP_P(( LDAP *ld, const char *dn ));
   int ldap_delete_s LDAP_P(( LDAP *ld, const char *dn ));
   int ldap_delete_ext LDAP_P (( LDAP *ld, const char *dn,
                                 LDAPControl **serverctrls,
                                 LDAPControl **clientctrls,
                                 int *msgidp));
   int ldap_delete_ext_s LDAP_P (( LDAP * ld, const char *dn,
                                   LDAPControl **serverctrls,
                                   LDAPControl **clientctrls));

   /* LDAP Error functions */
   int ldap_result2error LDAP_P(( LDAP *ld, LDAPMessage *r, int freeit ));
   char *ldap_err2string LDAP_P(( int err ));
   void ldap_perror LDAP_P(( LDAP *ld, const char *s ));
   int ldap_get_errno LDAP_P(( LDAP *ld ));
   int ldap_set_lderrno LDAP_P(( LDAP *ld, int e, const char *m, const char *s ));
   int ldap_get_lderrno LDAP_P(( LDAP *ld, char **m, char **s ));
   int ldap_get_exterror LDAP_P(( LDAP *ld )) ;
   char *ldap_pwdpolicy_err2string(int err);

   /* LDAP Modify functions */
   int ldap_modify LDAP_P(( LDAP *ld, const char *dn, LDAPMod **mods ));
   int ldap_modify_s LDAP_P(( LDAP *ld, const char *dn, LDAPMod **mods ));
   int ldap_modify_ext LDAP_P (( LDAP *ld, const char *dn, LDAPMod **mods,
                                 LDAPControl **serverctrls,
                                 LDAPControl **clientctrls,
                                 int *msgidp));
   int ldap_modify_ext_s LDAP_P (( LDAP *ld, const char *dn, LDAPMod **mods,
                                   LDAPControl **serverctrls,
                                   LDAPControl **clientctrls));

   /* LDAP Modrdn functions */
   int ldap_modrdn LDAP_P(( LDAP *ld, const char *dn, const char *newrdn,
                            int deleteoldrdn ));
   int ldap_modrdn_s LDAP_P(( LDAP *ld, const char *dn, const char *newrdn,
                              int deleteoldrdn));

   /* LDAP Init & Open functions */
   LDAP *ldap_open LDAP_P(( char *host, int port ));
   LDAP *ldap_init LDAP_P(( char *defhost, int defport ));

   /* LDAP Option functions */
   int ldap_set_option LDAP_P(( LDAP *ld, int optionToSet,
                                const void *optionValue ));
   int ldap_get_option LDAP_P(( LDAP *ld, int optionToGet,
                                void *optionValue ));
   int ldap_version LDAP_P((LDAPVersion *version));

   /* LDAP Entry functions */
   LDAPMessage *ldap_first_entry LDAP_P(( LDAP *ld, LDAPMessage *chain ));
   LDAPMessage *ldap_next_entry LDAP_P(( LDAP *ld, LDAPMessage *entry ));
   int ldap_count_entries LDAP_P(( LDAP *ld, LDAPMessage *chain ));

   /* LDAP Message functions */
   LDAPMessage *ldap_first_message LDAP_P(( LDAP *ld, LDAPMessage *chain));
   LDAPMessage *ldap_next_message LDAP_P(( LDAP *ld, LDAPMessage *chain));
   int ldap_count_messages LDAP_P(( LDAP *ld, LDAPMessage *chain));

   /* LDAP Referrence functions */
   LDAPMessage *ldap_first_reference LDAP_P ((LDAP *ld, LDAPMessage *res));
   LDAPMessage *ldap_next_reference LDAP_P ((LDAP *ld, LDAPMessage *res));
   int ldap_count_references LDAP_P((LDAP *ld, LDAPMessage *result));

   /* LDAP DN functions */
   char *ldap_get_dn LDAP_P(( LDAP *ld, LDAPMessage *entry ));
   char **ldap_explode_dns LDAP_P(( const char *dn ));
   char **ldap_explode_dn LDAP_P(( const char *dn, int notypes ));
   char **ldap_explode_rdn LDAP_P(( const char *rdn, int notypes));
   char *ldap_dn2ufn LDAP_P(( const char *dn));

   /* LDAP Attribute functions */
   char *ldap_first_attribute LDAP_P(( LDAP *ld, LDAPMessage *entry,
                                       BerElement **ber ));
   char *ldap_next_attribute LDAP_P(( LDAP *ld, LDAPMessage *entry,
                                      BerElement *ber ));
   int ldap_count_attributes LDAP_P(( LDAP *ld, LDAPMessage *entry ));

   /* LDAP Value functions */
   char **ldap_get_values LDAP_P(( LDAP *ld, LDAPMessage *entry,
                                   const char *target ));
   struct berval **ldap_get_values_len LDAP_P(( LDAP *ld,
                  LDAPMessage *entry, const char *target ));
   int ldap_count_values LDAP_P(( char **vals ));
   int ldap_count_values_len LDAP_P(( struct berval **vals ));
   void ldap_value_free LDAP_P(( char **vals ));
   void ldap_value_free_len LDAP_P(( struct berval **vals ));

   /* LDAP Result functions */
   int ldap_result LDAP_P(( LDAP *ld, int msgid, int all,
                            struct timeval *timeout, LDAPMessage **result ));
   int ldap_msgfree LDAP_P(( LDAPMessage *lm ));
   int ldap_msgid LDAP_P (( LDAPMessage *res));
   int ldap_msgtype LDAP_P ((LDAPMessage *res));

   /* LDAP Search functions */
   int ldap_search LDAP_P(( LDAP *ld, const char *base, int scope,
                            const char *filter, char ** attrs, int attrsonly ));
   int ldap_search_s LDAP_P(( LDAP *ld, const char *base, int scope,
                              const char *filter, char ** attrs, int attrsonly,
                              LDAPMessage **res ));
   int ldap_search_st LDAP_P(( LDAP *ld, const char *base, int scope,
                               const char *filter, char ** attrs, int attrsonly,
                               struct timeval *timeout, LDAPMessage **res ));
   int ldap_search_ext LDAP_P ((LDAP *ld, const char *base, int scope,
                                const char *filter, char ** attrs, int attrsonly,
                                LDAPControl **serverctrls, LDAPControl **clientctrls,
                                struct timeval *timeoutp, int sizelimit, int *msgidp));
   int ldap_search_ext_s LDAP_P ((LDAP *ld, const char *base, int scope,
                                  const char *filter, char ** attrs, int attrsonly,
                                  LDAPControl **serverctrls, LDAPControl **clientctrls,
                                  struct timeval *timeoutp, int sizelimit, LDAPMessage **res));

   /* LDAP sorted search extension */
typedef struct _LDAPsortkey {
      char *attr_type;  /* name of attribute */
      char *match_rule_oid; /* OID of matching rule */
      int reverse_order; /* specifies if attribute is sorted in reverse order */
   }
   LDAPsortkey;

   int ldap_create_sort_keylist LDAP_P ((LDAPsortkey ***sortKeyList, const char *sortString));
   void ldap_free_sort_keylist LDAP_P ((LDAPsortkey **sortKeyList));
   int ldap_create_sort_control LDAP_P ((LDAP *ld, LDAPsortkey **sortKeyList, const char isCritical, LDAPControl **control));
   int ldap_parse_sort_control LDAP_P ((LDAP *ld, LDAPControl **serverControls, unsigned long *sortRC, char **attribute));

   /* LDAP simple paged results extension */
   int ldap_create_page_control LDAP_P ((LDAP *ld, unsigned long pageSize, struct berval *cookie, const char isCritical, LDAPControl **control));
   int ldap_parse_page_control LDAP_P ((LDAP *ld, LDAPControl **serverControls, unsigned long *totalCount, struct berval **cookie));


   /* LDAP persistent search extensions */
   int ldap_create_persistentsearch_control LDAP_P((LDAP *ld, int changetypes, 
                                                    int changesonly, 
                                                    int return_echg_ctls, 
                                                    char ctl_iscritical, 
                                                    LDAPControl **ctrlp ));

   int ldap_parse_entrychange_control LDAP_P(( LDAP *ld, LDAPControl **ctrls,
                                               int *chgtypep, char **prevdnp,
                                               int *chgnumpresentp, 
                                               long *chgnump ));
   
    /* Transaction Related Functions*/
    LDAPControl * ldap_create_transaction_control(char * tran_id);
    int ldap_start_transaction(LDAP *ld, LDAPControl **serverctrls,
                               LDAPControl ** clientctrls, int *msgidp);
    int ldap_start_transaction_s(LDAP *ld, LDAPControl **serverctrls,
                                 LDAPControl ** clientctrls,
                                 struct berval **retdatap);
    int ldap_prepare_transaction(LDAP *ld, char * tran_id, LDAPControl **serverctrls,
                                 LDAPControl ** clientctrls, int *msgidp);
    int ldap_prepare_transaction_s(LDAP *ld, char * tran_id, LDAPControl **serverctrls,
                                   LDAPControl ** clientctrls);
    int ldap_end_transaction(LDAP *ld, char * tran_id, int abort,
                             LDAPControl **serverctrls, LDAPControl ** clientctrls,
                             int *msgidp);
    int ldap_end_transaction_s(LDAP *ld, char * tran_id, int abort,
                               LDAPControl **serverctrls, LDAPControl ** clientctrls);
    char * ldap_get_tran_id(struct berval * tran_id_bv);

   /* LDAP Unbind functions */
   int ldap_unbind LDAP_P(( LDAP *ld ));
   int ldap_unbind_s LDAP_P(( LDAP *ld ));
   int ldap_unbind_ext LDAP_P(( LDAP *ld, LDAPControl **serverctrls,
                                LDAPControl **clientcontrls ));

   /* LDAP Friendly functions */
   char *ldap_friendly_name LDAP_P(( char *filename, char *uname,
                                     FriendlyMap ** ));
   void ldap_free_friendlymap LDAP_P(( FriendlyMap ** ));

   /* LDAP Free functions */
   void ldap_mods_free LDAP_P(( LDAPMod **mods, int freemods ));
   void ldap_control_free LDAP_P ((LDAPControl *ctrl));
   void ldap_controls_free LDAP_P ((LDAPControl **ctrls));
   void ldap_memfree LDAP_P(( char *mem ));
   void ldap_ber_free LDAP_P(( BerElement *mem ));

   /* LDAP URL functions */
   int ldap_is_ldap_url LDAP_P(( char *url ));
   int ldap_url_parse LDAP_P(( char *url, LDAPURLDesc **ludpp ));
   void ldap_free_urldesc LDAP_P(( LDAPURLDesc *ludp ));
   int ldap_url_search LDAP_P(( LDAP *ld, char *url, int attrsonly ));
   int ldap_url_search_s LDAP_P(( LDAP *ld, char *url, int attrsonly,
                                  LDAPMessage **res ));
   int ldap_url_search_st LDAP_P(( LDAP *ld, char *url, int attrsonly,
                                   struct timeval *timeout, LDAPMessage **res ));

   /* LDAP SSL functions */
   int ldap_set_cipher LDAP_P(( LDAP *ld, char *userString ));

   int ldap_ssl_start LDAP_P((LDAP *ld, char *keyfile, char *keyfile_pw,
                              char *keyfile_dn));


#ifdef __OS400__

   int ldap_app_ssl_start_np LDAP_P(( LDAP *ld, char *cert_identifier));
   int ldap_app_ssl_client_init_np LDAP_P((char *dcm_identifier, int *pSSLReasonCode));
   LDAP *ldap_app_ssl_init_np LDAP_P((char *host, int port));
#endif

   int ldap_ssl_set_fips_mode_np LDAP_P((int setting));

   int ldap_ssl_client_init LDAP_P((char *keyfile,
                                    char *keyfile_pw,
                                    int sslTimeout,
                                    int *pSSLReasonCode )) ;

    /* #ifndef __OS400__ D99827.4  @A1C */

   int ldap_ssl_environment_init LDAP_P((const char *keyfile,
                                         const char *keyfile_pw,
                                         int sslTimeout,
                                         int *pSSLReasonCode )) ;
    /* #endif D99827.4  @A1C */

   LDAP *ldap_ssl_init LDAP_P((char *host,
                               int port,
                               const char *keyfile_dn )) ;

   int ldap_sasl_bind LDAP_P((LDAP *ld, const char *dn,
                              const char *mechanism, const struct berval *credentials,
                              LDAPControl **serverctrls,
                              LDAPControl **clientctrls,
                              int* msgidp));
   int ldap_sasl_bind_s LDAP_P(( LDAP *ld, const char* dn,
                                 const char *mechanism,
                                 const struct berval *credentials,
                                 LDAPControl **serverctrls,
                                 LDAPControl **clientctrls,
                                 struct berval **servercredp));

   int ldap_get_bind_controls LDAP_P(( LDAP *ld, LDAPControl ***bind_controls ));

   /* LDAP TLS functions */
   #ifdef __OS400__                                                           /* @A1A */
    int ldap_start_tls_app_np LDAP_P(( LDAP *ld, const char *applicationID )); /* @A1A */
   #endif                                                                     /* @A1A */
   int ldap_start_tls_s_np LDAP_P(( LDAP *ld, const char *certificateName ));

   int ldap_stop_tls_s_np LDAP_P(( LDAP *ld ));

   /* LDAP Rename function */
   int ldap_rename LDAP_P((LDAP* ld, const char *dn, const char *newdn,
                           const char *newparent,
                           int deleteoldrdn,
                           LDAPControl **serverctrls, LDAPControl **clientctrls,
                           int *msgidp));
   int ldap_rename_s LDAP_P((LDAP* ld, const char *dn, const char *newdn,
                             const char *newparent,
                             int deleteoldrdn,
                             LDAPControl **serverctrls, LDAPControl **clientctrls));

   /* LDAP Parse functions */
   int ldap_parse_result LDAP_P((LDAP* ld, LDAPMessage *result, int *errcodep,
                                 char **matcheddnp, char **errmsgp,
                                 char ***referralsp, LDAPControl ***serverctrlsp,
                                 int freeint )) ;
   int ldap_parse_reference LDAP_P((LDAP* ld, LDAPMessage *reference,
                                    char *** referralsp,
                                    LDAPControl*** serverctrlsp,
                                    int freeit));
   int ldap_parse_reference_np LDAP_P((LDAP* ld, LDAPMessage *reference,
                                       char *** referralsp,
                                       LDAPControl*** serverctrlsp,
                                       int freeit));
   int ldap_parse_pwdpolicy_response(LDAPControl **serverControls, int *controlerr, int *controlwarn, int *controlres);

   /* LDAP Control functions */
   int ldap_get_entry_controls LDAP_P(( LDAP *ld, LDAPMessage *entry,
                                        LDAPControl ***serverctrlsp ));
   int ldap_get_entry_controls_np LDAP_P(( LDAP *ld, LDAPMessage *entry,
                                           LDAPControl ***serverctrlsp ));
   int ldap_insert_control LDAP_P(( LDAPControl *newControl,
                                    LDAPControl ***ctrlList));

   int ldap_add_control LDAP_P(( const char *oid, ber_len_t len , char *value,
                                 int isCritical, LDAPControl ***ctrlList));
   int ldap_remove_control LDAP_P(( LDAPControl *delControl,
                                    LDAPControl ***ctrlList, int freeit));
   int ldap_copy_controls LDAP_P(( LDAPControl ***to_here, LDAPControl **from));

   int ldap_create_control LDAP_P(( LDAPControl ** pnewcontrol, 
                                    const char *oid, 
                                    ber_len_t data_len, 
                                    const char *data, 
                                    int critical));

   int ldap_parse_sasl_bind_result LDAP_P((LDAP* ld, LDAPMessage *result,
                                           struct berval **servercredp,
                                           int freeit));
   int ldap_server_locate LDAP_P((LDAPServerRequest *server_request,
                                  LDAPServerInfo **server_info_listpp));
   int ldap_server_free_list LDAP_P((LDAPServerInfo *server_info_listp));
   int ldap_server_conf_save LDAP_P((char *basename, unsigned long ttl,
                                     LDAPServerInfo *server_info_listp));
   int  ldap_create_proxyauth_control(LDAP *ld, const char *proxyDN,  int isCritical,
       LDAPControl **control);
   int ldap_proxy_dn_prefix(char **proxyDN, char *parm);
   LDAPControl * ldap_create_chaining_audit_control (char **uniqueIDs, char *clientIP, int critical);
   LDAPControl * ldap_create_group_control_from_list (char **listOfGroups, int normalized);
   LDAPControl * ldap_create_group_control (struct berval *sequenceOfGroups);
   struct berval * ldap_create_group_eval_request(const char *entryDN, char **attributes);
    struct berval * ldap_create_commit_transaction_request( const char *tran_id );
    struct berval * ldap_create_abort_transaction_request( const char *tran_id );
    struct berval * ldap_create_prepare_transaction_request( const char *tran_id );
   int ldap_create_omit_group_referential_integrity_control(LDAP *ld, LDAPControl **control);
   int ldap_create_modify_groups_only_control(LDAP *ld, LDAPControl **control);
   struct berval * ldap_create_account_status_request(const char *entryDN);

   struct berval * ldap_create_user_type_request();

#ifdef __OS400__
    int ldap_proxy_dn_prefix_utf8(char **proxyDN, char *parm);
#endif
#ifndef __OS400__ /* password APIs not supported by AS/400 */

   int ldap_password_set LDAP_P((char *encryption_key, char *password,
                                 unsigned long password_length, char *filename));
   int ldap_password_get LDAP_P((char *encryption_key, char **password,
                                 unsigned long *password_length, char *filename));
#endif /* end __OS400__ */

   int ldap_default_dn_set LDAP_P((char *default_dn, char *filename));
   int ldap_default_dn_get LDAP_P((char **dn, char *filename));
   int ldap_enetwork_domain_set LDAP_P((char *name, char *filename));
   int ldap_enetwork_domain_get LDAP_P((char **name, char *filename));

   /*
    For small, "one shot" translations, use an output buffer size that is
    3 times larger than the input buffer size, when going from local code page
    to UTF8.
   */
   int ldap_xlate_local_to_utf8 LDAP_P
   (( char *inbufp, unsigned long *inlenp, char *outbufp, unsigned long *outlenp ));
   int ldap_xlate_utf8_to_local LDAP_P
   (( char *inbufp, unsigned long *inlenp, char *outbufp, unsigned long *outlenp ));
   int ldap_xlate_local_to_unicode LDAP_P
   (( char *inbufp, unsigned long *inlenp, char *outbufp, unsigned long *outlenp ));
   int ldap_xlate_unicode_to_local LDAP_P
   (( char *inbufp, unsigned long *inlenp, char *outbufp, unsigned long *outlenp ));
   int ldap_set_locale LDAP_P(( const char *locale ));
   char * ldap_get_locale LDAP_P((void));
   int ldap_set_iconv_local_codepage LDAP_P(( char *codepage ));
   char * ldap_get_iconv_local_codepage LDAP_P((void));
   int ldap_set_iconv_local_charset LDAP_P(( char *charset ));
   int ldap_char_size LDAP_P((char *p));

   int ldap_parse_extended_result LDAP_P((
                                            LDAP *ld,
                                            LDAPMessage *res,
                                            char **resultoidp,
                                            struct berval **resultdata,
                                            int freeit
                                         ));

   int ldap_extended_operation LDAP_P((
                                         LDAP *ld,
                                         const char *exoid,
                                         const struct berval *exdata,
                                         LDAPControl **serverctrls,
                                         LDAPControl **clientctrls,
                                         int *msgidp
                                      ));

   int ldap_extended_operation_s LDAP_P((
                                           LDAP *ld,
                                           const char *exoid,
                                           const struct berval *exdata,
                                           LDAPControl **serverctrls,
                                           LDAPControl **clientctrls,
                                           char **retoidp,
                                           struct berval **retdatap
                                        ));
   struct berval *ldap_create_resume_role_request( int requestType,
                  char * partitionName,
                  char * serverName );


   /* LDAP Ber functions */
   void ber_bvfree LDAP_P(( struct berval *bv ));
   void ber_bvecfree LDAP_P(( struct berval **bv ));
   struct berval *ber_bvdup LDAP_P(( const struct berval *bv ));
   void ber_free LDAP_P(( BerElement *ber, int freebuf ));
   BerElement *ber_alloc_t LDAP_P (( int options ));
   int ber_printf LDAP_P(( BerElement *ber, const char *fmt, ... ));
   int ber_flatten LDAP_P(( const BerElement *ber, struct berval **bv ));
   void ber_init LDAP_P(( BerElement *ber, int options ));
   BerElement *ber_init2 LDAP_P(( const struct berval *bv ));
   ber_tag_t ber_scanf LDAP_P(( BerElement *ber, const char *fmt, ... ));
   ber_tag_t ber_get_tag LDAP_P(( BerElement *ber ));
   ber_tag_t ber_peek_tag LDAP_P(( BerElement *ber, ber_len_t *len ));
   ber_tag_t ber_skip_tag LDAP_P(( BerElement *ber, ber_len_t *len ));
   ber_tag_t ber_first_element LDAP_P(( BerElement *ber,
                                        ber_len_t *len, char **last ));
   ber_tag_t ber_next_element LDAP_P(( BerElement *ber,
                                       ber_len_t *len, char *last ));
   int ber_skip_element LDAP_P (( BerElement *ber ));

   /* LDAP FBer functions */
   BerElement *fber_init2 LDAP_P(( const struct berval *bv ));
   ber_tag_t fber_scanf LDAP_P(( BerElement *ber, const char *fmt, ... ));
   int fber_flatten LDAP_P(( const BerElement *ber, struct berval **bv ));
   BerElement *fber_alloc LDAP_P (( ));
   int fber_printf LDAP_P(( BerElement *ber, const char *fmt, ... ));
   void fber_free LDAP_P(( BerElement *ber ));
   /*********************************************************************
    
    Following section is used to develop client-side SASL plugins
    
   *********************************************************************/

#define LDAP_PLUGIN_TYPE   101
#define LDAP_PLUGIN_ARGV   102
#define LDAP_PLUGIN_ARGC   103
#define LDAP_PLUGIN_VERSION   104
#define LDAP_PLUGIN_OPRETURN   105
#define LDAP_PLUGIN_LD    106
#define LDAP_PLUGIN_TARGET_HOST   107

#define LDAP_PLUGIN_SASL_DN   201
#define LDAP_PLUGIN_SASL_BIND_CREDENTIALS 202
#define LDAP_PLUGIN_SASL_SERVER_CREDS  203
#define LDAP_PLUGIN_SASL_BIND_MECHANISM  204
#define LDAP_PLUGIN_SASL_BIND_CLIENTCTRLS 205
#define LDAP_PLUGIN_SASL_BIND_SERVERCTRLS 206
#define LDAP_PLUGIN_SASL_BIND_DEFAULT_REALM 207
#define LDAP_PLUGIN_SASL_BIND_DELEGATION 208
#define LDAP_PLUGIN_SASL_GSS_MAJOR_STATUS       209
#define LDAP_PLUGIN_SASL_GSS_MINOR_STATUS       210
#define LDAP_PLUGIN_SASL_GSS_CONTEXT_HANDLE     211

#define LDAP_PLUGIN_SASL_BIND_S_FN  301
#define LDAP_PLUGIN_TERMINATE_FN  302
#define LDAP_PLUGIN_KRB_INIT_FN   303
#define LDAP_PLUGIN_KRB_CC_DESTROY_FN 304
#define LDAP_PLUGIN_KRB_CTX_DESTROY_FN 305
#define LDAP_PLUGIN_KRB_BINDDN   306
#define LDAP_PLUGIN_KRB_PWD    307
#define LDAP_PLUGIN_KRB_CTX    308
#define LDAP_PLUGIN_KRB_CC    309
#define LDAP_PLUGIN_KRB_GSSERR   310

   typedef struct ldap_file_plugin_info {
      char *type;
      char *subtype;
      char *path;
      char *init;
      char *paramlist;

   }
   LDAP_File_Plugin_Info;

   /* Following APIs are used by an application to manage client-side SASL plugins */

   int ldap_register_plugin LDAP_P(( LDAP_File_Plugin_Info *plugin_info ));
   int ldap_query_plugin LDAP_P(( LDAP_File_Plugin_Info ***plugin_info ));
   int ldap_free_query_plugin LDAP_P(( LDAP_File_Plugin_Info ***plugin_info ));

   /* Following APIs are used to develop a client-side SASL plugin                 */

   int ldap_plugin_pblock_set LDAP_P(( LDAP_Pblock *pb, int name, void *value ));
   int ldap_plugin_pblock_get LDAP_P(( LDAP_Pblock *pb, int search_name, void **value ));
   int ldap_plugin_sasl_bind_s LDAP_P((
                                         LDAP *ld,
                                         const char *dn,
                                         const char *mechanism,
                                         const struct berval *credentials,
                                         LDAPControl **serverctrls,
                                         LDAPControl **clientctrls,
                                         struct berval **servercredp
                                      ));

#ifdef __OS400__

   char **ldap_explode_dn_utf8 LDAP_P(( char *dn, int notypes ));
   char **ldap_explode_rdn_utf8 LDAP_P(( char *rdn, int notypes));
   int ldap_url_parse_utf8 LDAP_P(( char *url, LDAPURLDesc **ludpp ));
    int ldap_is_ldap_url_utf8 LDAP_P(( char *url ));
#endif

#ifdef __cplusplus
}
#endif

#endif /* _LDAP_H */
