/* begin_generated_IBM_copyright_prolog                             */
/*                                                                  */
/* This is an automatically generated copyright prolog.             */
/* After initializing,  DO NOT MODIFY OR MOVE                       */
/* ---------------------------------------------------------------- */
/*                                                                  */
/* Product(s):                                                      */
/*     5647-A01                                                     */
/*     5796-SS1                                                     */
/*     5722-SS1                                                     */
/*                                                                  */
/* (C)Copyright IBM Corp.  1997, 2005                               */
/*                                                                  */
/* All rights reserved.                                             */
/* US Government Users Restricted Rights -                          */
/* Use, duplication or disclosure restricted                        */
/* by GSA ADP Schedule Contract with IBM Corp.                      */
/*                                                                  */
/* Licensed Materials-Property of IBM                               */
/*                                                                  */
/* ---------------------------------------------------------------- */
/*                                                                  */
/* end_generated_IBM_copyright_prolog                               */

/*
* COMPONENT_NAME: ldap.include
*
* ABSTRACT:
*
* FUNCTIONS:
*
* ORIGINS: 202,27
*
*/


#ifndef _SLAPI_PLUGIN_H
#define _SLAPI_PLUGIN_H

#ifdef __cplusplus
extern "C" {
#endif

#include "lber.h"
#include "ldap.h"

   /*slapi structs*/
   typedef struct slapi_pblock Slapi_PBlock;
   typedef struct slapi_entry Slapi_Entry;
   typedef struct slapi_attr Slapi_Attr;
   typedef struct slapi_filter Slapi_Filter;

   /* pblock routines */
   int slapi_pblock_get( Slapi_PBlock *pb, int arg, void *value );
   int slapi_pblock_set( Slapi_PBlock *pb, int arg, void *value );
   Slapi_PBlock *slapi_pblock_new();
   void slapi_pblock_destroy( Slapi_PBlock* );

   /*entry/attr/dn routines */
   Slapi_Entry *slapi_str2entry( char *s, int flags );
   char *slapi_entry2str( Slapi_Entry *e, int *len );
   char *slapi_entry_get_dn( Slapi_Entry *e );
   void slapi_entry_set_dn(Slapi_Entry *e, char *dn);
   Slapi_Entry *slapi_entry_dup(Slapi_Entry *e);
   int slapi_entry_attr_delete( Slapi_Entry *e, char *type );
   Slapi_Entry *slapi_entry_alloc();
   void slapi_entry_free( Slapi_Entry *e );
   int slapi_entry_attr_merge( Slapi_Entry *e, char *type,
                               struct berval **vals );
   int slapi_entry_attr_find( Slapi_Entry *e, char *type, Slapi_Attr **attr );
   int slapi_attr_get_values( Slapi_Attr *attr, struct berval ***vals );
   char *slapi_dn_normalize( char *dn ); /*deprecated*/
   char *slapi_dn_normalize_case( char *dn ); /*deprecated*/
   char *slapi_dn_normalize_v3( char *dn );
   char *slapi_dn_normalize_case_v3( char *dn );
   int slapi_dn_issuffix( char *dn, char *suffix );
   char *slapi_dn_ignore_case( char *dn );
   char *slapi_dn_ignore_case_v3( char *dn );
   int slapi_dn_compare_v3(char *dn1, char *dn2);

   /* char routines */
   char * slapi_ch_malloc( unsigned long size );
   void slapi_ch_free( void *ptr );
   char *slapi_ch_calloc( unsigned long nelem, unsigned long size );
   char *slapi_ch_realloc(char *block, unsigned long size );
   char *slapi_ch_strdup(const char *s );
   int slapi_ch_strcmp(const char *str1, const char *str2);
   int slapi_ch_strncmp(const char *str1, const char *str2, size_t size);


   /* LDAP V3 routines */
   int slapi_control_present( LDAPControl **controls, char *oid,
                              struct berval **val, int *iscritical);
   void slapi_register_supported_control(char *controloid,
                                         unsigned long controlops);
   int slapi_get_supported_controls(char ***ctrloidsp,
                                    unsigned long **ctrlopsp);
   void slapi_register_supported_saslmechanism(char *mechanism);
   void slapi_register_supported_saslmechanism( char *mechanism );
   char **slapi_get_supported_saslmechanisms();
   char **slapi_get_supported_extended_ops(void);


   /* send ldap result back */
   void slapi_send_ldap_result( Slapi_PBlock *pb, int err,
                                char *matched, char *text,
                                int nentries, struct berval **urls );
   int slapi_send_ldap_search_entry( Slapi_PBlock *pb, Slapi_Entry *e,
                                     LDAPControl **ectrls,
                                     char **attrs, int attrsonly );

   /* filter routines */
   Slapi_Filter *slapi_str2filter( char *str );
   void slapi_filter_free( Slapi_Filter *f, int recurse );
   int slapi_filter_get_choice( Slapi_Filter *f);
   int slapi_filter_get_ava( Slapi_Filter *f, char **type,
                             struct berval **bval );
   Slapi_Filter *slapi_filter_list_first( Slapi_Filter *f );
   Slapi_Filter *slapi_filter_list_next( Slapi_Filter *f, Slapi_Filter *fprev );

   /* internal add/delete/search/modify routines */
   Slapi_PBlock *slapi_search_internal( char *base, int scope, char *filter,
                                        LDAPControl **controls, char **attrs,
                                        int attrsonly );
   Slapi_PBlock *slapi_modify_internal( char *dn, LDAPMod **mods,
                                        LDAPControl **controls, int log_change);
   Slapi_PBlock *slapi_add_entry_internal( Slapi_Entry * e,
                                           LDAPControl **controls,
                                           int log_change );
   Slapi_PBlock *slapi_add_internal( char * dn, LDAPMod **attrs,
                                     LDAPControl **controls, int log_changes );
   Slapi_PBlock *slapi_add_entry_internal( Slapi_Entry * e,
                                           LDAPControl **controls,
                                           int log_change );
   Slapi_PBlock *slapi_delete_internal( char * dn, LDAPControl **controls,
                                        int log_change );
   Slapi_PBlock *slapi_modrdn_internal( char * olddn, char * newrdn,
                                        char *newParent, int deloldrdn,
                                        LDAPControl **controls,
                                        int log_change);
   void slapi_free_search_results_internal(Slapi_PBlock *pb);
   Slapi_PBlock *slapi_compare_internal( const char *dn,
	                                     const char *type,
										 struct berval *value,
										 LDAPControl **controls);

   /* connection related routines */
   int slapi_is_connection_ssl(Slapi_PBlock *pPB, int *isSSL);
   int slapi_get_client_port(Slapi_PBlock *pPB, int *fromPort);
   int slapi_get_client_ip(Slapi_PBlock *pPB, char ** clientIP);
   int slapi_get_source_ip(Slapi_PBlock *pPB, char ** sourceIP);

   /* logging routines */
   int slapi_log_error( int severity, char *subsystem, char *fmt, ... );

   int slapi_alloc_internal_pthread_mem();
   void slapi_free_internal_pthread_mem();

   /*audit routine*/
   int slapi_audit_extop (Slapi_PBlock *pb, char *str);
   /*Get the DN from the proxy auth control*/
   int slapi_get_proxied_dn(Slapi_PBlock *pb, char ** proxiedDN);

   /* plugin types supported */

#define SLAPI_PLUGIN_DATABASE           1
#define SLAPI_PLUGIN_EXTENDEDOP         2
#define SLAPI_PLUGIN_PREOPERATION       3
#define SLAPI_PLUGIN_POSTOPERATION      4
#define SLAPI_PLUGIN_AUDIT              7

   /* misc params */

#define SLAPI_BACKEND               130
#define SLAPI_CONNECTION            131
#define SLAPI_OPERATION             132

   /* operation params */

   /* connection  structure params*/
#define SLAPI_CONN_DN                   143
#define SLAPI_CONN_AUTHTYPE             144
#ifndef SLAPI_IBM_CONN_DN_ORIG
#define SLAPI_IBM_CONN_DN_ORIG          -47
#endif

   /*  Authentication types */
#define SLAPD_AUTH_NONE   "none"
#define SLAPD_AUTH_SIMPLE "simple"
#define SLAPD_AUTH_SSL    "SSL"
#define SLAPD_AUTH_SASL   "SASL "

   /* plugin configuration parmams */
#define SLAPI_PLUGIN                3
#define SLAPI_PLUGIN_PRIVATE        4
#define SLAPI_PLUGIN_TYPE           5
#define SLAPI_PLUGIN_ARGV           6
#define SLAPI_PLUGIN_ARGC           7

   /* internal opreations params */
#define SLAPI_PLUGIN_INTOP_RESULT       15
#define SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES   16

   /* function pointer params for backends */
#define SLAPI_PLUGIN_DB_BIND_FN         200
#define SLAPI_PLUGIN_DB_UNBIND_FN       201
#define SLAPI_PLUGIN_DB_SEARCH_FN       202
#define SLAPI_PLUGIN_DB_COMPARE_FN      203
#define SLAPI_PLUGIN_DB_MODIFY_FN       204
#define SLAPI_PLUGIN_DB_MODRDN_FN       205
#define SLAPI_PLUGIN_DB_ADD_FN          206
#define SLAPI_PLUGIN_DB_DELETE_FN       207
#define SLAPI_PLUGIN_DB_CONFIG_FN       209
#define SLAPI_PLUGIN_CLOSE_FN           210


   /*  functions pointers for LDAP V3 extended ops */
#define SLAPI_PLUGIN_EXT_OP_FN          300
#define SLAPI_PLUGIN_EXT_OP_OIDLIST     301

   /*updateConfig*/
#define SLAPI_UPDATE_CONFIG    302

   /* functions for preoperation functions */
#define SLAPI_PLUGIN_PRE_BIND_FN        401
#define SLAPI_PLUGIN_PRE_UNBIND_FN      402
#define SLAPI_PLUGIN_PRE_SEARCH_FN      403
#define SLAPI_PLUGIN_PRE_COMPARE_FN     404
#define SLAPI_PLUGIN_PRE_MODIFY_FN      405
#define SLAPI_PLUGIN_PRE_MODRDN_FN      406
#define SLAPI_PLUGIN_PRE_ADD_FN         407
#define SLAPI_PLUGIN_PRE_DELETE_FN      408

   /*  functions for postoperation functions*/
#define SLAPI_PLUGIN_POST_BIND_FN       501
#define SLAPI_PLUGIN_POST_UNBIND_FN     502
#define SLAPI_PLUGIN_POST_SEARCH_FN     503
#define SLAPI_PLUGIN_POST_COMPARE_FN    504
#define SLAPI_PLUGIN_POST_MODIFY_FN     505
#define SLAPI_PLUGIN_POST_MODRDN_FN     506
#define SLAPI_PLUGIN_POST_ADD_FN        507
#define SLAPI_PLUGIN_POST_DELETE_FN     508

   /* audit plugin defines */
#define SLAPI_PLUGIN_AUDIT_DATA          1100
#define SLAPI_PLUGIN_AUDIT_FN            1101
#define SLAPI_PLUGIN_AUDIT_CLEAR         1102

   /* managedsait control */
#define SLAPI_MANAGEDSAIT                1000

   /* config stuff */
#define SLAPI_CONFIG_FILENAME       40
#define SLAPI_CONFIG_LINENO         41
#define SLAPI_CONFIG_ARGC           42
#define SLAPI_CONFIG_ARGV           43

   /*  operational params */
#define SLAPI_TARGET_DN             50
#define SLAPI_REQCONTROLS           51

   /* server LDAPv3 controls  */

   /* add params */
#define SLAPI_ADD_TARGET            SLAPI_TARGET_DN
#define SLAPI_ADD_ENTRY             60

   /* bind params */
#define SLAPI_BIND_TARGET           SLAPI_TARGET_DN
#define SLAPI_BIND_METHOD           70
#define SLAPI_BIND_CREDENTIALS      71
#define SLAPI_BIND_SASLMECHANISM    72
#define SLAPI_BIND_RET_SASLCREDS    73

   /* compare params */
#define SLAPI_COMPARE_TARGET        SLAPI_TARGET_DN
#define SLAPI_COMPARE_TYPE          80
#define SLAPI_COMPARE_VALUE         81

   /* delete params */
#define SLAPI_DELETE_TARGET         SLAPI_TARGET_DN

   /* modify params */
#define SLAPI_MODIFY_TARGET         SLAPI_TARGET_DN
#define SLAPI_MODIFY_MODS           90

   /* modrdn params */
#define SLAPI_MODRDN_TARGET_UP      SLAPI_TARGET_DN
#define SLAPI_MODRDN_TARGET         100
#define SLAPI_MODRDN_NEWRDN         101
#define SLAPI_MODRDN_DELOLDRDN      102
#define SLAPI_MODRDN_NEWSUPERIOR    103     /* v3 only */

   /* search params */
#define SLAPI_SEARCH_TARGET         SLAPI_TARGET_DN
#define SLAPI_SEARCH_SCOPE          110
#define SLAPI_SEARCH_DEREF          111
#define SLAPI_SEARCH_SIZELIMIT      112
#define SLAPI_SEARCH_TIMELIMIT      113
#define SLAPI_SEARCH_FILTER         114
#define SLAPI_SEARCH_STRFILTER      115
#define SLAPI_SEARCH_ATTRS          116
#define SLAPI_SEARCH_ATTRSONLY      117

   /* abandon params */
#define SLAPI_ABANDON_MSGID         120

   /* extended operation params */
#define SLAPI_EXT_OP_REQ_OID        160
#define SLAPI_EXT_OP_REQ_VALUE      161

   /* extended operation return codes */
#define SLAPI_EXT_OP_RET_OID        162
#define SLAPI_EXT_OP_RET_VALUE      163

  /*audit string for extended op*/
#define SLAPI_EXT_OP_AUDIT_STR		164
#define SLAPI_EXT_OP_AUDIT_RET_CODE	166

#define SLAPI_PLUGIN_EXTENDED_SENT_RESULT   -1

   /* Search result params */
#define SLAPI_NENTRIES              195


   /* filter types */
#define LDAP_FILTER_AND         0xa0L
#define LDAP_FILTER_OR          0xa1L
#define LDAP_FILTER_NOT         0xa2L
#define LDAP_FILTER_EQUALITY    0xa3L
#define LDAP_FILTER_SUBSTRINGS  0xa4L
#define LDAP_FILTER_GE          0xa5L
#define LDAP_FILTER_LE          0xa6L
#define LDAP_FILTER_PRESENT     0x87L
#define LDAP_FILTER_APPROX      0xa8L
#define LDAP_FILTER_EXT_MATCH   0xa9L

   /*Operation types*/
#define SLAPI_OPERATION_BIND            0x00000001L
#define SLAPI_OPERATION_UNBIND          0x00000002L
#define SLAPI_OPERATION_SEARCH          0x00000004L
#define SLAPI_OPERATION_MODIFY          0x00000008L
#define SLAPI_OPERATION_ADD             0x00000010L
#define SLAPI_OPERATION_DELETE          0x00000020L
#define SLAPI_OPERATION_MODDN           0x00000040L
#define SLAPI_OPERATION_MODRDN          SLAPI_OPERATION_MODDN
#define SLAPI_OPERATION_COMPARE         0x00000080L
#define SLAPI_OPERATION_EXTENDED        0x00000200L
#define SLAPI_OPERATION_ANY             0xFFFFFFFFL
#define SLAPI_OPERATION_NONE            0x00000000L

   /* Message severity levels for
      slapi_log_error( int severity, char *subsystem, char *fmt, ... ); 
    */
#ifndef LDAP_MSG_LOW
#define LDAP_MSG_LOW    0x0001
#endif

#ifndef LDAP_MSG_MED
#define LDAP_MSG_MED    0x0002
#endif

#ifndef LDAP_MSG_HIGH
#define LDAP_MSG_HIGH   0x0004
#endif

   /* Admin ID used by the slapi_internal APIs */
#define SLAPI_ADMIN_ID "CN=SLAPI_ADMIN"

#ifdef __cplusplus
}
#endif

#endif
